library ProgramTree;

uses 
  System.Collections.Generic;
  
type 
  Node = class //         
  end;
  
  ExprNode = class(Node) //     
  end;

  IdNode = class(ExprNode) 
  public
    name: string;
    constructor (name: string);
    begin
      Self.name := name;
    end;
  end;

  NumNode = class(ExprNode)
  public
    num: integer;  
    constructor (num: integer);
    begin
      Self.num := num;
    end;
  end;
  
  StatementNode = class(Node) //     
  end;  
  
  AssignNode = class(StatementNode)
  public
    id: IdNode;
    expr: ExprNode;
    assop: integer;
    constructor (id: IdNode; expr: ExprNode; assop: integer);
    begin
      Self.id := id;
      Self.expr := expr;
      Self.assop := assop;
    end;
  end;
  
  CycleNode = class(StatementNode)
  public
    ex: ExprNode;
    st: StatementNode;
    constructor (ex: ExprNode; st: StatementNode);
    begin
      Self.ex := ex;
      Self.st := st;
    end;
  end;

  BlockNode = class(StatementNode)
  public
    stlist: List<StatementNode>;
    constructor ();
    begin
      stlist := new List<StatementNode>();
    end;
    constructor (st: StatementNode);
    begin
      stlist := new List<StatementNode>();
      stlist.Add(st);
    end;
    procedure Add(st: StatementNode);
    begin
      stlist.Add(st);
    end;
  end;
  
  ProgrNode = class(Node)
  public
    body: BlockNode;
    constructor (body: BlockNode);
    begin
      Self.body := body;
    end;
  end;
  
end.